"This script is intended to be used mostly with the "x11" user interface.
"It defines several spelling-related toolbar buttons.  It also sets the
"hlspell and showspell options regardless of the GUI, and it loads the
"whole spelling dictionary into RAM.
if gui=="x11"
then {
  gui gap
  gui Spell:se neghlspell
  gui Spell"Toggle spell-checking on/off
  gui Spell=hlspell
  gui Misspelled:spell
  gui Misspelled"Find next misspelled word
  gui Ignore:eval words! (current(/\I\i*\('\I\+\)\?/))
  gui Ignore"Accept this as a legal word, but don't add to dictionary
  gui Learn:eval words (current(/\I\i*\('\I\+\)\?/))
  gui Learn"Add this word to your personal dictonary
  gui Fix?spell(current(/\I\i*\('\I\+\)\?/))[0] == 1
  gui Fix:spellfix
  gui Fix"Correct the spelling of this word
  alias spellfix {
    " Used by the [Fix] button
    local s i

    " Choose a canned option, or the "Other" string.  For the canned options,
    " we need to strip off the leading digit-colon characters.
    if c == "Other"
    then let s = o
    else let s = c[,3..]

    " Convert any slashes to spaces.  The spell() function uses slashes to
    " suggest possible places to cut a misspelled word in two.
    for i (1 .. strlen(s))
    do {
      if (s[,i]) == "/"
      then let s[,i] = " "
    }

    " Construct a :s/// command
    let s = "s/\\<";w;"\\>/";s;"/"

    " Apply the :s/// command either once or globally
    if e
    then eval % (s)g
    else eval (s)

    " Maybe advance to next misspelled word
    if n
    then spell
  }
  alias spell {
    local w s c i
    " Move to the next misspelled word, if any
    normal 
    let w = current(/\I\i*\('\I\+\)\?/)
    let s = spell(w)
    message (s << (columns - 10))

    "If using the x11 user interface, then customize the [Fix] dialog
    if gui == "x11"
    then {
      let c = "gui Fix;\"Bad word\" w = \"";w;"\";"
      if s == "?"
      then let c = c "\"Corrected\" c = o;"
      else {
	let c = c "\"Corrected\" (oneof"
	for i (1 .. 9)
	do {
	  if s[i]
	  then let c = c (i;":";s[i])
	}
	let c = c "Other) c = \"Other\"; \"Other\" o;"
      }
      let c = c "\"Fix everywhere?\" (boolean)e = false;"
      let c = c "\"Find next?\" (boolean)n"
      eval (c)
    }
  }
}
wordfile
set hlspell showspell
